//433 МГц Atmega328 передает показания каждые 8 с
//имитирует темп+влажность, измеряет батарейку
//ФКВгштщ Uno
// питание схемы 3,3 В!  
//Передатчик SYN115 вывод 10 (D10,PB2, вывод 16 ATmega)
//осреднение батарейки методом скользящего среднего
//схема Датчик_proba_m328.png

#include <VirtualWire.h>
#include <avr/wdt.h>
#include <avr/sleep.h>

#define ledPin 13 //вывод светодиода (PB5 вывод 19 ATmega)

char msg[17]; //посылаемый месседж
volatile int batt[4]; //для осреднения батарейки
volatile byte count=0;//счетчик для осреднения
volatile int total=0; //сумма измерений
float volt=0; //усредненное значение кода вольт
unsigned int v_kod; //целое значение кода 4 разряда
volatile boolean first_meas=true; //признак начального заполнения массива  

//****************************************************************  
// перевод системы в режим сна
void system_sleep() {
  ADCSRA &= ~(1 << ADEN);//cbi(ADCSRA,ADEN); выключим АЦП
  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // режим сна
  sleep_mode();                        // система засыпает
    sleep_disable(); // система продолжает работу после переполнения watchdog
    ADCSRA |= (1 << ADEN);//sbi(ADCSRA,ADEN); включаем АЦП
}

//****************************************************************
// 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms
// 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec
void setup_watchdog(int ii) {
  byte bb;
  if (ii > 9 ) ii=9;
  bb=ii & 7;
  if (ii > 7) bb|= (1<<5); //в bb - код периода
  bb|= (1<<WDCE);
  MCUSR &= ~(1<<WDRF);
  // запуск таймера
  WDTCSR |= (1<<WDCE) | (1<<WDE);
  // установка периода срабатывания сторожевого таймера
  WDTCSR = bb;
  WDTCSR |= (1<<WDIE); //прерывание WDT  
}
//****************************************************************  
// Обработка прерывания сторожевого таймера 
// выполняется при истечении установленного для него периода
ISR(WDT_vect) {
        wdt_reset();
}

void setup() {
  analogReference(INTERNAL);
  vw_setup(1200); // Скорость соединения VirtualWire
  vw_set_tx_pin(10);   //(D10,PB2, вывод 16 ATmega передача VirtualWire
  setup_watchdog(9); //8 c
  wdt_reset();
  pinMode(13, OUTPUT); //светодиод
}

void loop() {
  wdt_reset();
  digitalWrite(ledPin, HIGH);
//===== осреднение батарейки
  total = total - batt[count]; // вычитаем последнее значение из суммы
  batt[count]=analogRead(0); // считываем значение 
  total = total + batt[count]; //добавляем считанное значение к сумме
  count++; //увеличиваем счетчик
   // считаем среднее:
 if (first_meas)  //если первое заполнение массива
  volt = float(total) / float(count);
 else  
  volt = float(total)/4;
  v_kod = int(volt)*10; //переводим в целое
  if (count==4) {count=0; first_meas=false;} 
//======имитация температуры и влажности
//  int tmpr = temperature*10+2731; //температуру с десятыми в целое положительное число 4 разряда 
    int  tmpr=2931; //+20.0 град
    int  hum=1990; // hum = humidity*10+1000 - аналогично temp в 4 разряда
  String strMsg="DAT"; //сигнатура - данные
  strMsg+=tmpr; //температуру в строку
  strMsg+=hum; //присоединяем влажность
  strMsg+=v_kod; //присоединяем код батарейки целое 4 разряда
  strMsg.toCharArray(msg,16); //переводим строку в массив, здесь 16 – количество знаков
  vw_send((uint8_t *)msg, strlen(msg)); // Передача сообщения
  vw_wait_tx(); // Ждем завершения передачи*/
  digitalWrite(ledPin, LOW);
  system_sleep();
} //end loop









