//Приемник 433 МГц Arduino Uno/Nano
// Плата SYN480R
// вывод приемника D3
// контроль приема через Serial 9600
// схема Priemnik_Arduino.png

#include <VirtualWire.h>
#define Ledpin 13

  float tempr=0;
  unsigned int hum=0;
  unsigned int batt;
  float volt;
char str[5];
  uint8_t buf[VW_MAX_MESSAGE_LEN];  // Переменная для хранения принятых данных
  uint8_t buflen = VW_MAX_MESSAGE_LEN;  // max длина принятых данных

volatile uint16_t t_time = 0; //время приема

void setup() {
  vw_setup(1200); // Скорость соединения VirtualWire
  vw_rx_start();  // Готовность приема
  vw_set_rx_pin(3); // Вывод приемника VirtualWire
  Serial.begin(9600);
  pinMode(Ledpin,OUTPUT);
}

void loop() {
  vw_rx_start();  // Готовность приема
  buflen = VW_MAX_MESSAGE_LEN; //размер буфера каждый раз иницировать по новой
  if ((int(millis()) - t_time) > 48000) //если t_time не обновлялось более 48 сек
  {
    Serial.println("Datchik not found");
    delay(1000);
  }//end датчик не найден

  if (vw_get_message(buf, &buflen)) // Пришло! Считываем и анализируем
  {
    vw_rx_stop();
      for (byte i=0;i<3;i++)  // Получить первые три байта
                str[i]= buf[i];   
      str[3]='\0'; //терминирующий ноль на всякий
      if((str[0]=='D')&&(str[1]=='A')&&(str[2]=='T')) {
        //тот самый датчик сигнатура "DAT"
       digitalWrite(Ledpin,HIGH);        
       t_time = millis(); // обновляем t_time 
         Serial.print(str); // выводим сигнатуру
         Serial.print(' '); // выводим пробел
// === температура
      for (byte i=3;i<7;i++)  // Получить четыре байта ASCII-кода температуры
                str[i-3]= buf[i]; // упаковать их в строку
      int value=atoi(str); //преобразовать в целое число
      value=value-2731; //вычесть 2731 - в целые Цельсия с целыми десятыми и знаком
      tempr=(float(value)/10); //с десятыми долями
         Serial.print(tempr,1); // выводим температуру с одним знаком
         Serial.print("*C"); // выводим Цельсия
         Serial.print(' '); // выводим пробел
// === влажность
      for (byte i=7;i<11;i++)  // Получить четыре байта ASCII-кода влажности
                str[i-7]= buf[i]; // упаковать их в строку
      int hh=atoi(str); //преобразовать в целое число
      hum=(hh-1000)/10; //влажность 
      if ((hum<100)&&(hum>0)){
          Serial.print(hum); // выводим только валидное значение влажности 
          Serial.print('%'); // выводим процент
          Serial.print(' '); // выводим пробел
        }//end влажность
// ==== батарейка
      for (byte i=11;i<15;i++)  // Получить четыре байта ASCII-кода батарейки
                str[i-11]= buf[i]; // упаковать их в строку
      batt=atoi(str); //преобразовать в целое число
      batt=(batt/10);
      volt=(float(batt)/1024)*5.6; //коэффициент калибруется по месту
          Serial.print(volt,1); // выводим батарейку 
          Serial.println("V"); // конец строки
       digitalWrite(Ledpin,LOW);        
      }//end if str=DAT
  } //end get_message
   for (byte i=0;i<15;i++) { str[i]=0; buf[i]=0;} //очищаем буфер и строку
  delay(100);
      digitalWrite(Ledpin,LOW);
}//end loop
